SystemOrganization addCategory: #'JMG-MetroidClock'!

Morph subclass: #MetroidClock
	instanceVariableNames: 'steppingInterval numberMethodDict backgroundNumberColor backgroundColor numberColor'
	classVariableNames: ''
	poolDictionaries: 'ChronologyConstants'
	category: 'JMG-MetroidClock'!

!MetroidClock methodsFor: 'accessing' stamp: 'jmg 9/12/2011 17:32'!
backgroundColor
	backgroundColor
		ifNil: [backgroundColor := Color black].
	^ backgroundColor! !

!MetroidClock methodsFor: 'accessing' stamp: 'jmg 9/12/2011 17:38'!
backgroundColor: aColor 
	backgroundColor := aColor.
	self color: self backgroundColor.  ! !

!MetroidClock methodsFor: 'accessing' stamp: 'jmg 9/14/2011 13:46'!
backgroundNumberColor
	backgroundNumberColor
		ifNil: [backgroundNumberColor := Color
						r: 61
						g: 61
						b: 61
						range: 255].
	^ backgroundNumberColor! !

!MetroidClock methodsFor: 'accessing' stamp: 'jmg 9/12/2011 17:33'!
backgroundNumberColor: aColor
backgroundNumberColor := aColor.! !

!MetroidClock methodsFor: 'drawing' stamp: 'jmg 9/12/2011 17:29'!
drawBackGroundEightAt: aCellNumber on: aCanvas 
	| rect topLeft |
	topLeft := self left + (aCellNumber * 13) @ self top.
	rect := Rectangle origin: topLeft extent: 13 @ 13.
	0
		to: 6
		do: [:i | aCanvas
				fillRectangle: (rect translateBy: 0 @ (i * 13))
				color: self backgroundNumberColor ].
	0
		to: 6
		do: [:i | aCanvas
				fillRectangle: (rect translateBy: 6 * 13 @ (i * 13))
				color: self backgroundNumberColor ].
	1
		to: 6
		do: [:i | aCanvas
				fillRectangle: (rect translateBy: i * 13 @ 0)
				color: self backgroundNumberColor ].
	1
		to: 6
		do: [:i | aCanvas
				fillRectangle: (rect translateBy: i * 13 @ (3 * 13))
				color: self backgroundNumberColor ].
	1
		to: 6
		do: [:i | aCanvas
				fillRectangle: (rect translateBy: i * 13 @ (6 * 13))
				color: self backgroundNumberColor ]! !

!MetroidClock methodsFor: 'drawing' stamp: 'jmg 9/12/2011 17:21'!
drawBackgroundNumbers: aCanvas 
	self drawBackGroundEightAt: 0 on: aCanvas.
	self drawBackGroundEightAt: 8 on: aCanvas.
	self drawBackGroundEightAt: 18 on: aCanvas.
	self drawBackGroundEightAt: 26 on: aCanvas.
	self drawBackGroundEightAt: 36 on: aCanvas.
	self drawBackGroundEightAt: 44 on: aCanvas.
	self drawColonAt: 16 on: aCanvas.
	self drawColonAt: 34 on: aCanvas.! !

!MetroidClock methodsFor: 'drawing' stamp: 'jmg 9/12/2011 17:20'!
drawColonAt: cellNumber on: aCanvas 
	| rect |
	rect := Rectangle origin: self topLeft extent: 13 @ 13.
	aCanvas
		fillRectangle: (rect translateBy: cellNumber * 13 @ 13)
		color: Color white.
	aCanvas
		fillRectangle: (rect translateBy: cellNumber * 13 @ (5 * 13))
		color: Color white! !

!MetroidClock methodsFor: 'drawing' stamp: 'jmg 9/14/2011 09:41'!
drawCurrentTime: aCanvas 
	| currentTime currentHours currentMinutes currentSeconds |
	currentTime := Time current.
	currentHours := currentTime hour24.
	currentMinutes := currentTime minutes.
	currentSeconds := currentTime seconds.
	currentHours < 10 ifTrue: [currentHours := '0' , currentHours asString ] ifFalse:  [currentHours := currentHours asString ]. 
	currentHours asString
		doWithIndex: [:char :index | 
			| number block cellNumber |
			cellNumber := index - 1 * 7 + (index - 1 * 1).
			number := char asString asInteger.
			block := self numberMethodDict at: number.
			block value: cellNumber value: aCanvas].
	currentMinutes < 10
		ifTrue: [currentMinutes := '0' , currentMinutes asString]
		ifFalse: [currentMinutes := currentMinutes asString].
	currentMinutes
		doWithIndex: [:char :index | 
			| number block cellNumber |
			cellNumber := index + 1 * 7 + (index - 1 * 1) + 4.
			number := char asString asInteger.
			block := self numberMethodDict at: number.
			block value: cellNumber value: aCanvas].
	currentSeconds < 10
		ifTrue: [currentSeconds := '0' , currentSeconds asString]
		ifFalse: [currentSeconds := currentSeconds asString].
	currentSeconds
		doWithIndex: [:char :index | 
			| number block cellNumber |
			cellNumber := index + 1 * 7 + (index - 1 * 1) + 22.
			number := char asString asInteger.
			block := self numberMethodDict at: number.
			block value: cellNumber value: aCanvas]! !

!MetroidClock methodsFor: 'drawing-numbers' stamp: 'jmg 9/14/2011 11:23'!
drawEightAt: cellNumber on: aCanvas 
	| rect topLeft |
	topLeft := self left + (cellNumber * 13) @ self top.
	rect := Rectangle origin: topLeft extent: 13 @ 13.
	self drawVerticalLineOnLeft: aCanvas usingRect: rect.
	self drawVerticalLineOnRight: aCanvas usingRect: rect.
	self drawHorizontalLineAtTop: aCanvas usingRect: rect.
	self drawHorizontalLineAtMiddle: aCanvas usingRect: rect.
	self drawHorizontalLineAtBottom: aCanvas usingRect: rect.! !

!MetroidClock methodsFor: 'drawing-numbers' stamp: 'jmg 9/14/2011 11:31'!
drawFiveAt: cellNumber on: aCanvas 
	| rect topLeft |
	topLeft := self left + (cellNumber * 13) @ self top.
	rect := Rectangle origin: topLeft extent: 13 @ 13.
	self drawHorizontalLineAtTop: aCanvas usingRect: rect.
	self drawHorizontalLineAtMiddle: aCanvas usingRect: rect.
	self drawHorizontalLineAtBottom: aCanvas usingRect: rect.
	self drawVerticalHalfLineOnLeftAtTop: aCanvas usingRect: rect.
	self drawVerticalHalfLineOnRightAtBottom: aCanvas usingRect: rect! !

!MetroidClock methodsFor: 'drawing-numbers' stamp: 'jmg 9/14/2011 11:33'!
drawFourAt: cellNumber on: aCanvas 
	| rect topLeft |
	topLeft := self left + (cellNumber * 13) @ self top.
	rect := Rectangle origin: topLeft extent: 13 @ 13.
	self drawVerticalHalfLineOnLeftAtTop: aCanvas usingRect: rect.
	self drawVerticalLineOnRight: aCanvas usingRect: rect.
	self drawHorizontalLineAtMiddle: aCanvas usingRect: rect.! !

!MetroidClock methodsFor: 'drawing-primitives' stamp: 'jmg 9/14/2011 11:23'!
drawHorizontalLineAtBottom: aCanvas usingRect: aRect
0
		to: 6
		do: [:i | aCanvas
				fillRectangle: (aRect translateBy: i * 13 @ (6 * 13))
				color: self numberColor]! !

!MetroidClock methodsFor: 'drawing-primitives' stamp: 'jmg 9/14/2011 11:22'!
drawHorizontalLineAtMiddle: aCanvas usingRect: aRect
0
		to: 6
		do: [:i | aCanvas
				fillRectangle: (aRect translateBy: i * 13 @ (3 * 13))
				color: self numberColor].
	! !

!MetroidClock methodsFor: 'drawing-primitives' stamp: 'jmg 9/14/2011 11:21'!
drawHorizontalLineAtTop: aCanvas usingRect: aRect 
	0
		to: 6
		do: [:i | aCanvas
				fillRectangle: (aRect translateBy: i * 13 @ 0)
				color: self numberColor]! !

!MetroidClock methodsFor: 'drawing-numbers' stamp: 'jmg 9/14/2011 11:37'!
drawNineAt: cellNumber on: aCanvas 
	| rect topLeft |
	topLeft := self left + (cellNumber * 13) @ self top.
	rect := Rectangle origin: topLeft extent: 13 @ 13.
	self drawHorizontalLineAtTop: aCanvas usingRect: rect.
	self drawHorizontalLineAtMiddle: aCanvas usingRect: rect.
	self drawHorizontalLineAtBottom: aCanvas usingRect: rect.
	self drawVerticalHalfLineOnLeftAtTop: aCanvas usingRect: rect.
	self drawVerticalLineOnRight: aCanvas usingRect: rect! !

!MetroidClock methodsFor: 'drawing' stamp: 'jmg 9/12/2011 13:10'!
drawOn: aCanvas 
	| newCanvas |
	super drawOn: aCanvas.
	newCanvas := aCanvas asBalloonCanvas.
	newCanvas aaLevel: 4.
	newCanvas := ClippingCanvas canvas: newCanvas clipRect: self bounds.
	self drawBackgroundNumbers: newCanvas.
	self drawCurrentTime: newCanvas.! !

!MetroidClock methodsFor: 'drawing-numbers' stamp: 'jmg 9/14/2011 11:39'!
drawOneAt: cellNumber on: aCanvas 
	| rect topLeft |
	topLeft := self left + (cellNumber * 13) @ self top.
	rect := Rectangle origin: topLeft extent: 13 @ 13.
	self drawVerticalLineOnRight: aCanvas usingRect: rect! !

!MetroidClock methodsFor: 'drawing-numbers' stamp: 'jmg 9/14/2011 11:38'!
drawSevenAt: cellNumber on: aCanvas 
	| rect topLeft |
	topLeft := self left + (cellNumber * 13) @ self top.
	rect := Rectangle origin: topLeft extent: 13 @ 13.
	self drawVerticalLineOnRight: aCanvas usingRect: rect.
	self drawHorizontalLineAtTop: aCanvas usingRect: rect.! !

!MetroidClock methodsFor: 'drawing-numbers' stamp: 'jmg 9/14/2011 11:43'!
drawSixAt: cellNumber on: aCanvas 
	| rect topLeft |
	topLeft := self left + (cellNumber * 13) @ self top.
	rect := Rectangle origin: topLeft extent: 13 @ 13.
	self drawHorizontalLineAtTop: aCanvas usingRect: rect.
	self drawHorizontalLineAtMiddle: aCanvas usingRect: rect.
	self drawHorizontalLineAtBottom: aCanvas usingRect: rect.
	self drawVerticalLineOnLeft: aCanvas usingRect: rect.
	self drawVerticalHalfLineOnRightAtBottom: aCanvas usingRect: rect.! !

!MetroidClock methodsFor: 'drawing-numbers' stamp: 'jmg 9/14/2011 11:42'!
drawThreeAt: cellNumber on: aCanvas 
	| rect topLeft |
	topLeft := self left + (cellNumber * 13) @ self top.
	rect := Rectangle origin: topLeft extent: 13 @ 13.
	self drawVerticalLineOnRight: aCanvas usingRect: rect.
	self drawHorizontalLineAtTop: aCanvas usingRect: rect.
	self drawHorizontalLineAtMiddle: aCanvas usingRect: rect.
	self drawHorizontalLineAtBottom: aCanvas usingRect: rect.! !

!MetroidClock methodsFor: 'drawing-numbers' stamp: 'jmg 9/14/2011 11:41'!
drawTwoAt: cellNumber on: aCanvas 
	| rect topLeft |
	topLeft := self left + (cellNumber * 13) @ self top.
	rect := Rectangle origin: topLeft extent: 13 @ 13.
	self drawHorizontalLineAtTop: aCanvas usingRect: rect.
	self drawHorizontalLineAtMiddle: aCanvas usingRect: rect.
	self drawHorizontalLineAtBottom: aCanvas usingRect: rect.
	self drawVerticalHalfLineOnRightAtTop: aCanvas usingRect: rect.
	self drawVerticalHalfLineOnLeftAtBottom: aCanvas usingRect: rect.! !

!MetroidClock methodsFor: 'drawing-primitives' stamp: 'jmg 9/14/2011 11:30'!
drawVerticalHalfLineOnLeftAtBottom: aCanvas usingRect: aRect 
	3
		to: 6
		do: [:i | aCanvas
				fillRectangle: (aRect translateBy: 0 @ (i * 13))
				color: self numberColor]! !

!MetroidClock methodsFor: 'drawing-primitives' stamp: 'jmg 9/14/2011 11:30'!
drawVerticalHalfLineOnLeftAtTop: aCanvas usingRect: aRect 
	0
		to: 3
		do: [:i | aCanvas
				fillRectangle: (aRect translateBy: 0 @ (i * 13))
				color: self numberColor]! !

!MetroidClock methodsFor: 'drawing-primitives' stamp: 'jmg 9/14/2011 11:30'!
drawVerticalHalfLineOnRightAtBottom: aCanvas usingRect: aRect 
	3
		to: 6
		do: [:i | aCanvas
				fillRectangle: (aRect translateBy: 6 * 13 @ (i * 13))
				color: self numberColor]! !

!MetroidClock methodsFor: 'drawing-primitives' stamp: 'jmg 9/14/2011 11:30'!
drawVerticalHalfLineOnRightAtTop: aCanvas usingRect: aRect 
	0
		to: 3
		do: [:i | aCanvas
				fillRectangle: (aRect translateBy: 6 * 13 @ (i * 13))
				color: self numberColor]! !

!MetroidClock methodsFor: 'drawing-primitives' stamp: 'jmg 9/14/2011 11:19'!
drawVerticalLineOnLeft: aCanvas usingRect: aRect
0
		to: 6
		do: [:i | aCanvas
				fillRectangle: (aRect translateBy: 0 @ (i * 13))
				color: self numberColor].
! !

!MetroidClock methodsFor: 'drawing-primitives' stamp: 'jmg 9/14/2011 11:20'!
drawVerticalLineOnRight: aCanvas usingRect: aRect
0
		to: 6
		do: [:i | aCanvas
				fillRectangle: (aRect translateBy: 6 * 13 @ (i * 13))
				color: self numberColor].! !

!MetroidClock methodsFor: 'drawing-numbers' stamp: 'jmg 9/14/2011 11:40'!
drawZeroAt: cellNumber on: aCanvas 
	| rect topLeft |
	topLeft := self left + (cellNumber * 13) @ self top.
	rect := Rectangle origin: topLeft extent: 13 @ 13.
	self drawVerticalLineOnRight: aCanvas usingRect: rect.
	self drawVerticalLineOnLeft: aCanvas usingRect: rect.
	self drawHorizontalLineAtTop: aCanvas usingRect: rect.
	self drawHorizontalLineAtBottom: aCanvas usingRect: rect.! !

!MetroidClock methodsFor: 'initialization' stamp: 'jmg 9/12/2011 17:28'!
initialize
	super initialize.
	self color: self backgroundColor.
	self extent: 663 @ 91.
	self startStepping! !

!MetroidClock methodsFor: 'private' stamp: 'jmg 9/12/2011 16:52'!
initializeNumberMethodDict
	numberMethodDict
		add: (Association
				key: 0
				value: [:cellNumber :canvas | self drawZeroAt: cellNumber on: canvas]).
	numberMethodDict
		add: (Association
				key: 1
				value: [:cellNumber :canvas | self drawOneAt: cellNumber on: canvas]).
	numberMethodDict
		add: (Association
				key: 2
				value: [:cellNumber :canvas | self drawTwoAt: cellNumber on: canvas]).
	numberMethodDict
		add: (Association
				key: 3
				value: [:cellNumber :canvas | self drawThreeAt: cellNumber on: canvas]).
	numberMethodDict
		add: (Association
				key: 4
				value: [:cellNumber :canvas | self drawFourAt: cellNumber on: canvas]).
	numberMethodDict
		add: (Association
				key: 5
				value: [:cellNumber :canvas | self drawFiveAt: cellNumber on: canvas]).
	numberMethodDict
		add: (Association
				key: 6
				value: [:cellNumber :canvas | self drawSixAt: cellNumber on: canvas]).
	numberMethodDict
		add: (Association
				key: 7
				value: [:cellNumber :canvas | self drawSevenAt: cellNumber on: canvas]).
					numberMethodDict
		add: (Association
				key: 8
				value: [:cellNumber :canvas | self drawEightAt: cellNumber on: canvas]).
					numberMethodDict
		add: (Association
				key: 9
				value: [:cellNumber :canvas | self drawNineAt: cellNumber on: canvas]).! !

!MetroidClock methodsFor: 'accessing' stamp: 'jmg 9/14/2011 11:11'!
numberColor
	numberColor ifNil: [numberColor := Color white].
	^ numberColor! !

!MetroidClock methodsFor: 'accessing' stamp: 'jmg 9/14/2011 11:10'!
numberColor: aColor
	numberColor := aColor.! !

!MetroidClock methodsFor: 'accessing' stamp: 'jmg 9/12/2011 16:46'!
numberMethodDict
	numberMethodDict ifNil: [numberMethodDict := Dictionary new. self initializeNumberMethodDict.].
	^ numberMethodDict.   ! !

!MetroidClock methodsFor: 'initialization' stamp: 'jmg 9/14/2011 13:46'!
resetToDefaultColors
	self numberColor: Color white.
	self backgroundColor: Color black.
	self
		backgroundNumberColor: (Color
				r: 61
				g: 61
				b: 61
				range: 255)! !

!MetroidClock methodsFor: 'stepping and presenter' stamp: 'jmg 9/12/2011 17:55'!
step
	| milliSecondsToNextSecond |
	milliSecondsToNextSecond := 1000 - (Time current nanoSecond / NanosInSecond).
	self steppingInterval: milliSecondsToNextSecond asFloat rounded.
	self changed! !

!MetroidClock methodsFor: 'testing' stamp: 'jmg 9/12/2011 13:07'!
stepTime
	^ self steppingInterval! !

!MetroidClock methodsFor: 'accessing' stamp: 'jmg 9/12/2011 12:56'!
steppingInterval
	steppingInterval
		ifNil: [steppingInterval := 60000].
	^ steppingInterval! !

!MetroidClock methodsFor: 'accessing' stamp: 'jmg 9/12/2011 13:05'!
steppingInterval: numberOfMilliseconds 
	steppingInterval := numberOfMilliseconds.
	"self stopStepping.
	self startStepping"! !
